program SmallBall2 ;

import "hiper3d";

global

//Variables

int Score;
int Cam_X;
int Cam_Y;
int Player_X;
int Player_Y;
int Player_Rotation_X;
int Player_Rotation_Y;
int Camera_Rotation_Z;
int On;
int BackGroundMap;
int Global_X_Velocity;
int Global_Y_Velocity;
int Points;
int Level;
int Lives;
int Background3D;
float x2;
float y2;
int ScoreCounter;
int EnemyClose;
struct Saves[1];
  int HiScore;
  int Lvl1Score;
  int Lvl2Score;
  int Lvl3Score;
  int Lvl4Score;
  int Lvl5Score;
  int Lvl6Score;
  int Lvl7Score;
  int Lvl8Score;
  int Lvl9Score;
  int Lvl10Score;
  int Lvl11Score;
  int Lvl12Score;
  int Lvl13Score;
  int Lvl14Score;
  int Lvl15Score;
  int TopLevel;
  int OriginalScore;
  int OriginalPoints;
end
int LevelDone;
int Boss_X;
int Boss_Y;
int Boss3_X;
int Boss3_Y;
int Boss3_Angle;
int MainMenuSelection;
int LevelMenuSelection;
int SingleLevel;
int MenuTransition;
int PlayerDead;
int InvincibleCounter;
int WindOn;
int Spark_X;
int Spark_Y;
int SparkEnemy_Alpha;
int Boss2DamageOn;
int Bee_X;
int Bee_Y;
int Bee_Angle;

//Models

int Bkg3D1;
int Bkg3D0;
int Bkg3D3;
int Bkg3D4;
int Bkg3D5;
int Bkg3D6;
int Bkg3D7;
int Bkg3D8;
int Bkg3D9;
int Bkg3D10;
int Bkg3D11;
int Bkg3D12;
int Sphere;

//Sound INT's

int Poff;
int Pop;
int Bip;
int Neotron;
int Zap;
int Explode;
int Launch;
int Beam;
int Laser;
int Splash;
int Snake;
int Earth;
int Rocks;
int Bounce;
int Song;

begin

Full_Screen=true;
set_mode(640,480,16);
load_fpg("ball2.fpg");
load("score.dat",Saves);
set_fps(30,0);

Poff=load_wav("Sound/poff.wav");
Pop=load_wav("Sound/pop.wav");
Bip=load_wav("Sound/bip.wav");
Neotron=load_wav("Sound/neotron_zoom.wav");
Zap=load_wav("Sound/zap.wav");
Explode=load_wav("Sound/explode.wav");
Launch=load_wav("Sound/launch.wav");
Beam=load_wav("Sound/beam.wav");
Laser=load_wav("Sound/laser.wav");
Splash=load_wav("Sound/splash.wav");
Snake=load_wav("Sound/snake.wav");
Earth=load_wav("Sound/earth.wav");
Rocks=load_wav("Sound/rocks.wav");
Bounce=load_wav("Sound/bounce.wav");

BackgroundMap=new_map(640,480,16);
init_hiper3d(0,BackgroundMap);

//init_hiper3d(0,0);

Lives=3;
ScoreCounter=640;

//Saves[1].TopLevel=15;

GameIntro();

//TitleScreen();

//MainMenu();

//Original3D();

//World1Intro();
//World2Intro();
//World3Intro();
//World4Intro();
//World5Intro();

//Level0(15);
//Level1(15);
//Level3(15);
//Level4(15);
//Level5(15);
//Level6(15);
//Level7(20);
//Level8(20);
//Level9(15);
//Level10(20);
//Level11(20);
//Level12(15);
//Level13(20);
//Level14(20);
//Level15(20);

//WinGame();

//repeat frame; until(key(_esc))

end


process GameIntro();
private
int Counter;
begin
Counter=0; repeat Counter++; frame; until(Counter==10)
play_wav(Neotron,0);

ZoomOut(320,100,0,78,0,20,3);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,100,1,3);
  Particle_Splash(320,100,1,4);
  Particle_Splash(420,100,1,3);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==20)
ZoomOut(320,380,0,79,0,20,3);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,380,1,3);
  Particle_Splash(320,380,1,5);
  Particle_Splash(420,380,1,3);
until(Counter==8)
Counter=0; repeat Counter++; frame; until(Counter==10)

repeat
  if (rand(1,30)==1) SmallBallAnimation1(-10,rand(10,470),1,165); end
  frame;
until(key(_space) or key(_enter))
let_me_alone();

TitleScreen();

end



process TitleScreen();
private
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball_meny.ogg");
play_song(Song,99);

DisplayScreenObject(320,240,4,83,100,0);

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,80,0,87,0,10,1);
repeat
  Counter++;
  Particle_Splash(220,80,1,2);
  Particle_Splash(320,80,1,2);
  Particle_Splash(420,80,1,2);
until(Counter==8)

Counter=0;
ZoomOut(320,240,0,214,0,10,1);
repeat
  Counter++;
  Particle_Splash(300,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(340,240,1,2);
until(Counter==8)

Counter=0;
repeat
  if (Counter<200) Counter++; end

  if (Counter==20) TitleSmallBall(320,240,3,0); end
  if (Counter==40) TitleSmallBall(320,240,3,0); end
  if (Counter==60) TitleSmallBall(320,240,3,0); end
  if (Counter==80) TitleSmallBall(320,240,3,0); end
  if (Counter==100) TitleSmallBall(320,240,3,0); end
  if (Counter==120) TitleSmallBall(320,240,3,0); end
  if (Counter==140) TitleSmallBall(320,240,3,0); end
  if (Counter==160) TitleSmallBall(320,240,3,0); end
  if (Counter==180) TitleSmallBall(320,240,3,0); end
  
  frame;
until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();

MainMenu();

end



process MainMenu();
private
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball_meny.ogg");
play_song(Song,99);

let_me_alone();
delete_3dobject(Background3D);
stop_scroll(0);

MenuTransition=0;
ScoreCounter=0;
Points=0;
Lives=3;
ScoreCounter=640;
WindOn=0;
Boss2DamageOn=0;

Bkg3D0=load_mesh("Models/bkg0.md2");
Bkg3D1=load_mesh("Models/bkg1.md2");
Bkg3D3=load_mesh("Models/bkg3.md2");
Bkg3D4=load_mesh("Models/bkg4.md2");
Bkg3D5=load_mesh("Models/bkg5.md2");
Bkg3D6=load_mesh("Models/bkg6.md2");
Bkg3D7=load_mesh("Models/bkg7.md2");
Bkg3D8=load_mesh("Models/bkg8.md2");
Bkg3D9=load_mesh("Models/bkg9.md2");
Bkg3D10=load_mesh("Models/bkg10.md2");
Bkg3D11=load_mesh("Models/bkg11.md2");
Bkg3D12=load_mesh("Models/bkg12.md2");

DisplayScreenObject(320,240,4,88,100,0);

MenuOption(160,50,3,89,5,0);

MenuOption(160,150,3,90,10,0);
MenuOption(160,210,3,91,15,0);
MenuOption(160,270,3,92,20,0);
MenuOption(160,330,3,115,25,0);
MenuOption(160,390,3,93,25,0);
MenuOption(160,450,3,94,30,0);

if (Saves[1].TopLevel=>1) MenuOption(480,30,3,98,30,0); else MenuOption(480,30,3,98,30,1); end
if (Saves[1].TopLevel=>2) MenuOption(480,60,3,99,28,0); else MenuOption(480,60,3,99,28,1); end
if (Saves[1].TopLevel=>3) MenuOption(480,90,3,100,26,0); else MenuOption(480,90,3,100,26,1); end

if (Saves[1].TopLevel=>4) MenuOption(480,120,3,101,24,0); else MenuOption(480,120,3,101,24,1); end
if (Saves[1].TopLevel=>5) MenuOption(480,150,3,102,22,0); else MenuOption(480,150,3,102,22,1); end
if (Saves[1].TopLevel=>6) MenuOption(480,180,3,103,20,0); else MenuOption(480,180,3,103,20,1); end

if (Saves[1].TopLevel=>7) MenuOption(480,210,3,104,18,0); else MenuOption(480,210,3,104,18,1); end
if (Saves[1].TopLevel=>8) MenuOption(480,240,3,105,16,0); else MenuOption(480,240,3,105,16,1); end
if (Saves[1].TopLevel=>9) MenuOption(480,270,3,106,14,0); else MenuOption(480,270,3,106,14,1); end

if (Saves[1].TopLevel=>10) MenuOption(480,300,3,107,12,0); else MenuOption(480,300,3,107,12,1); end
if (Saves[1].TopLevel=>11) MenuOption(480,330,3,108,10,0); else MenuOption(480,330,3,108,10,1); end
if (Saves[1].TopLevel=>12) MenuOption(480,360,3,109,8,0); else MenuOption(480,360,3,109,8,1); end

if (Saves[1].TopLevel=>13) MenuOption(480,390,3,110,6,0); else MenuOption(480,390,3,110,6,1); end
if (Saves[1].TopLevel=>14) MenuOption(480,420,3,111,4,0); else MenuOption(480,420,3,111,4,1); end
if (Saves[1].TopLevel=>15) MenuOption(480,450,3,112,2,0); else MenuOption(480,450,3,112,2,1); end

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

MenuSelector(160,50,3);
MainMenuSelection=1;

repeat
  if (key(_up))
    MainMenuSelection--;
    play_wav(Bip,0);
    frame;
  end
  if (key(_down))
    MainMenuSelection++;
    play_wav(Bip,0);
    frame;
  end
  frame;
  if (MainMenuSelection==0) MainMenuSelection=6; end
  if (MainMenuSelection==7) MainMenuSelection=1; end
until (key(_enter) or key(_space))

if (MainMenuSelection==1)
  MenuTransition=1;
  FadeIn(75);
  Counter=0; repeat Counter++; frame; until(Counter==30) 
  World1Intro();
end
if (MainMenuSelection==2) if (Saves[1].TopLevel==0) MainMenu(); end end
if (MainMenuSelection==3)
  if (Saves[1].TopLevel==0) MainMenu(); end
  SingleLevel=1;
end
if (MainMenuSelection==4)
  MenuTransition=1;
  FadeIn(75);
  Counter=0; repeat Counter++; frame; until(Counter==30)
  HighScores();
end
if (MainMenuSelection==5)
  MenuTransition=1;
  FadeIn(75);
  Counter=0; repeat Counter++; frame; until(Counter==30)
  Original3D();
end
if (MainMenuSelection==6)
  MenuTransition=1;
  FadeIn(75);
  Counter=0; repeat Counter++; frame; until(Counter==30)
  exit("Quit",0);
end

signal (type MenuSelector, s_kill);
frame; frame; frame;
MenuSelector(480,30,3);
LevelMenuSelection=1;

repeat
  if (key(_up))
    LevelMenuSelection--;
    play_wav(Bip,0);
  end
  if (key(_down))
    LevelMenuSelection++;
    play_wav(Bip,0);
  end
  frame; frame;
  if (LevelMenuSelection==0) LevelMenuSelection=Saves[1].TopLevel; end
  if (LevelMenuSelection==Saves[1].TopLevel+1) LevelMenuSelection=1; end
until (key(_enter) or key(_space) or key(_esc))

if (key(_esc)) MainMenu(); end

MenuTransition=1;
FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();

if (LevelMenuSelection==1) Level0(15); return; end
if (LevelMenuSelection==2) Level1(15); return; end
if (LevelMenuSelection==3) Level3(15); return; end
if (LevelMenuSelection==4) Level4(15); return; end
if (LevelMenuSelection==5) Level5(15); return; end
if (LevelMenuSelection==6) Level6(15); return; end
if (LevelMenuSelection==7) Level7(20); return; end
if (LevelMenuSelection==8) Level8(20); return; end
if (LevelMenuSelection==9) Level9(15); return; end
if (LevelMenuSelection==10) Level10(20); return; end
if (LevelMenuSelection==11) Level11(20); return; end
if (LevelMenuSelection==12) Level12(15); return; end
if (LevelMenuSelection==13) Level13(20); return; end
if (LevelMenuSelection==14) Level14(20); return; end
if (LevelMenuSelection==15) Level15(15); return; end

World1Intro();

end




process HighScores();
private
int Counter;
begin

let_me_alone();
MenuTransition=0;

DisplayScreenObject(320,240,4,88,100,0);

MenuOption(160,30,3,98,30,0);
MenuOption(160,60,3,99,28,0);
MenuOption(160,90,3,100,26,0);

MenuOption(160,120,3,101,24,0);
MenuOption(160,150,3,102,22,0);
MenuOption(160,180,3,103,20,0);

MenuOption(160,210,3,104,18,0);
MenuOption(160,240,3,105,16,0);
MenuOption(160,270,3,106,14,0);

MenuOption(160,300,3,107,12,0);
MenuOption(160,330,3,108,10,0);
MenuOption(160,360,3,109,8,0);

MenuOption(160,390,3,110,6,0);
MenuOption(160,420,3,111,4,0);
MenuOption(160,450,3,112,2,0);

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

write_int(0,350,25,0,&Saves[1].Lvl1Score);
write_int(0,350,55,0,&Saves[1].Lvl2Score);
write_int(0,350,85,0,&Saves[1].Lvl3Score);

write_int(0,350,115,0,&Saves[1].Lvl4Score);
write_int(0,350,145,0,&Saves[1].Lvl5Score);
write_int(0,350,175,0,&Saves[1].Lvl6Score);

write_int(0,350,205,0,&Saves[1].Lvl7Score);
write_int(0,350,235,0,&Saves[1].Lvl8Score);
write_int(0,350,265,0,&Saves[1].Lvl9Score);

write_int(0,350,295,0,&Saves[1].Lvl10Score);
write_int(0,350,325,0,&Saves[1].Lvl11Score);
write_int(0,350,355,0,&Saves[1].Lvl12Score);

write_int(0,350,385,0,&Saves[1].Lvl13Score);
write_int(0,350,415,0,&Saves[1].Lvl14Score);
write_int(0,350,445,0,&Saves[1].Lvl15Score);

repeat frame; until(key(_enter) or key(_space) or key(_esc))

delete_text(0);
MenuTransition=1;
FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
MainMenu();

end





process World1Intro();
private
int Counter;
begin

let_me_alone();
stop_scroll(0);

DisplayScreenObject(320,240,2,74,100,0);
DisplayScreenObject(320,240,0,73,100,0);

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

SmallBallAnimation1(205,255,1,55);

Counter=0; repeat Counter++; frame; until(Counter==30)
ZoomOut(320,100,0,72,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,100,1,2);
  Particle_Splash(320,100,1,2);
  Particle_Splash(420,100,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==20)
ZoomOut(320,380,0,68,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,380,1,2);
  Particle_Splash(320,380,1,2);
  Particle_Splash(420,380,1,2);
until(Counter==8)


Counter=0; repeat Counter++; frame; until(Counter==30)

repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)
let_me_alone();

Level0(15);

end



process World2Intro();
private
int Counter;
begin

let_me_alone();
stop_scroll(0);

DisplayScreenObject(320,240,2,144,100,0);
DisplayScreenObject(320,240,0,73,100,0);

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

SmallBallAnimation1(205,255,1,55);

Counter=0; repeat Counter++; frame; until(Counter==30)
ZoomOut(320,100,0,125,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,100,1,2);
  Particle_Splash(320,100,1,2);
  Particle_Splash(420,100,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==20)
ZoomOut(320,380,0,124,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,380,1,2);
  Particle_Splash(320,380,1,2);
  Particle_Splash(420,380,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==30)

repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)
let_me_alone();

Level4(15);

end



process World3Intro();
private
int Counter;
begin

let_me_alone();
stop_scroll(0);

DisplayScreenObject(320,240,2,145,100,0);
DisplayScreenObject(320,240,0,73,100,0);

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

SmallBallAnimation1(205,255,1,55);

Counter=0; repeat Counter++; frame; until(Counter==30)
ZoomOut(320,100,0,143,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,100,1,2);
  Particle_Splash(320,100,1,2);
  Particle_Splash(420,100,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==20)
ZoomOut(320,380,0,141,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,380,1,2);
  Particle_Splash(320,380,1,2);
  Particle_Splash(420,380,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==30)

repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)
let_me_alone();

Level7(15);

end



process World4Intro();
private
int Counter;
begin

let_me_alone();
stop_scroll(0);

DisplayScreenObject(320,240,2,159,100,0);
DisplayScreenObject(320,240,0,73,100,0);

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

SmallBallAnimation1(205,255,1,55);

Counter=0; repeat Counter++; frame; until(Counter==30)
ZoomOut(320,100,0,160,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,100,1,2);
  Particle_Splash(320,100,1,2);
  Particle_Splash(420,100,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==20)
ZoomOut(320,380,0,157,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,380,1,2);
  Particle_Splash(320,380,1,2);
  Particle_Splash(420,380,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==30)

repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)
let_me_alone();

Level10(20);

end


process World5Intro();
private
int Counter;
begin

let_me_alone();
stop_scroll(0);

DisplayScreenObject(320,240,2,201,100,0);
DisplayScreenObject(320,240,0,73,100,0);

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

SmallBallAnimation1(205,255,1,55);

Counter=0; repeat Counter++; frame; until(Counter==30)
ZoomOut(320,100,0,186,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,100,1,2);
  Particle_Splash(320,100,1,2);
  Particle_Splash(420,100,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==20)
ZoomOut(320,380,0,187,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,380,1,2);
  Particle_Splash(320,380,1,2);
  Particle_Splash(420,380,1,2);
until(Counter==8)

Counter=0; repeat Counter++; frame; until(Counter==30)

repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)
let_me_alone();

Level13(20);

end



process Level0(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=0;
LevelDone=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(64,13,0,30);
LevelCheck(65,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D0);
set_texture(Background3D,load_texture(0,16));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
DrawBackground(320,240,2);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,68,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,70,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl1Score)
  Saves[1].Lvl1Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level1(15);

end



process Level1(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=1;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(12,13,0,30);
LevelCheck(14,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D1);
set_texture(Background3D,load_texture(0,16));
set_rot(Background3D,90,0,0);
x2=335; y2=230;

NoEnemyArea(567,576,20,63);
NoEnemyArea(632,307,20,63);

Point(320,240,960,720,4,1);
BoxEnemy(320,240,960,720,3,rand(1,2),rand(1,2));
DrawBackground(320,240,2);

x=640; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,68,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>420) x--; end
  if (y>300) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,71,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>420) x--; end
  if (y>300) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>420) x--; end
  if (y>300) y--; end
  frame(50);
until(Counter==130)

Player(420,300,4);
ScoreTimer();
Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;

if (Score>Saves[1].Lvl2Score)
  Saves[1].Lvl2Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,0,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat
  frame;
until(key(_space) or key(_enter))
let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level3(15);

end





process Level3(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=2;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(64,13,0,30);
LevelCheck(65,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D0);
set_texture(Background3D,load_texture(0,16));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,0);
Boss1(640,480,4,1);
DrawBackground(320,240,2);

x=600; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,68,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,69,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();
Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;

if (Score>Saves[1].Lvl3Score)
  Saves[1].Lvl3Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);

ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

World2Intro();

end




process Level4(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=3;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(119,123,0,30);
LevelCheck(120,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D3);
set_texture(Background3D,load_texture(0,126));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
DrawBackground(320,240,2);
Enemy_Snake(800,480,4);

SlowDownWorldObject(500,580,10,121,100,0);
SlowDownWorldObject(819,385,10,122,100,0);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,124,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,70,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  if (rand(1,35)==1) WhirlWind(353,266,929,690,9,1); end
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl4Score)
  Saves[1].Lvl4Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level5(15);

end





process Level5(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=4;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(128,123,0,30);
LevelCheck(129,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D4);
set_texture(Background3D,load_texture(0,126));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
DrawBackground(320,240,2);
Enemy_Snake(600,320,4);
Enemy_Snake(700,600,4);

SlowDownWorldObject(783,580,10,121,100,1);
SlowDownWorldObject(464,385,10,122,100,1);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,124,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,71,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  if (rand(1,35)==1) WhirlWind(353,266,929,690,9,1); end
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl5Score)
  Saves[1].Lvl5Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level6(15);

end




process Level6(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=5;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(119,123,0,30);
LevelCheck(120,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D3);
set_texture(Background3D,load_texture(0,126));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,0);
Boss2(640,480,4,1);

DrawBackground(320,240,2);

SlowDownWorldObject(500,580,10,121,100,0);
SlowDownWorldObject(819,385,10,122,100,0);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,124,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,69,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  if (rand(1,35)==1) WhirlWind(353,266,929,690,9,1); end
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl6Score)
  Saves[1].Lvl6Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

World3Intro();

end




process Level7(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=6;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(137,136,0,30);
LevelCheck(140,640,480,20);

DisplayScreenObject(320,240,1,146,100,2);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D5);
set_texture(Background3D,load_texture(0,147));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
Bees(640,480,3);
DrawBackground(320,240,2);

SlowDownWorldObject(549,388,10,139,100,0);
SlowDownWorldObject(833,603,10,138,100,0);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,141,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,70,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl7Score)
  Saves[1].Lvl7Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level8(20);

end




process Level8(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=7;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(148,136,0,30);
LevelCheck(149,640,480,20);

DisplayScreenObject(320,240,1,146,100,2);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D6);
set_texture(Background3D,load_texture(0,147));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
Bees(640,480,3);
DrawBackground(320,240,2);

SlowDownWorldObject(733,391,10,139,100,1);
SlowDownWorldObject(449,603,10,138,100,1);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,141,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,71,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl8Score)
  Saves[1].Lvl8Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level9(15);

end




process Level9(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=8;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(137,136,0,30);
LevelCheck(140,640,480,20);

DisplayScreenObject(320,240,1,146,100,2);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D5);
set_texture(Background3D,load_texture(0,147));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
Boss3();
DrawBackground(320,240,2);

SlowDownWorldObject(549,388,10,139,100,0);
SlowDownWorldObject(833,603,10,138,100,0);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,141,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,69,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl9Score)
  Saves[1].Lvl9Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

World4Intro();

end



process Level10(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=9;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;
WindOn=1;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(152,151,0,30);
LevelCheck(153,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D7);
set_texture(Background3D,load_texture(0,161));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
DrawBackground(320,240,2);

Enemy_Fish(860,300,6,1);
Enemy_Fish(880,450,6,1);
Enemy_Fish(900,600,6,1);

SlowDownWorldObject(800,480,10,155,100,0);

Wind(-320,240,1,1);
Wind(320,240,1,1);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,157,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,70,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl10Score)
  Saves[1].Lvl10Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);
WindOn=0;

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level11(20);

end



process Level11(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=10;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;
WindOn=1;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(162,151,0,30);
LevelCheck(163,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D8);
set_texture(Background3D,load_texture(0,161));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
DrawBackground(320,240,2);

Enemy_Fish(500,650,6,2);
Enemy_Fish(500,670,6,2);
Enemy_Fish(900,650,6,2);
Enemy_Fish(900,670,6,2);

SlowDownWorldObject(640,585,10,164,100,0);

Wind(-320,240,1,1);
Wind(320,240,1,1);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,157,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,71,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl11Score)
  Saves[1].Lvl11Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);
WindOn=0;

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level12(15);

end




process Level12(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=11;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;
WindOn=1;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(152,151,0,30);
LevelCheck(153,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D9);
set_texture(Background3D,load_texture(0,161));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
DrawBackground(320,240,2);

Boss4();

SlowDownWorldObject(800,480,10,155,100,0);

Wind(-320,240,1,1);
Wind(320,240,1,1);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,157,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,69,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl12Score)
  Saves[1].Lvl12Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);
WindOn=0;

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

World5Intro();

end



process Level13(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=12;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(171,170,0,30);
LevelCheck(172,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D10);
set_texture(Background3D,load_texture(0,188));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
DrawBackground(320,240,2);

ConveyorRight(639,298,10);
ConveyorDown(848,478,10);
ConveyorLeft(639,658,10);
ConveyorUp(429,477,10);

SpinAlarm(-10,-10,1);
SpinAlarm(650,-10,1);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,187,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,70,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();
SparkEnemy(640,480,4,2);

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl13Score)
  Saves[1].Lvl13Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level14(20);

end




process Level14(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=13;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(199,170,0,30);
LevelCheck(200,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D11);
set_texture(Background3D,load_texture(0,188));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2));
DrawBackground(320,240,2);

ConveyorRight(638,504,10);
ConveyorLeft(638,476,10);
ConveyorRight(638,445,10);

ConveyorLeft(638,383,10);
ConveyorRight(638,567,10);

SpinAlarm(-10,-10,1);
SpinAlarm(650,-10,1);

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,187,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,71,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();
SparkEnemy(640,460,4,2);
SparkEnemy(640,500,4,1);

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl14Score)
  Saves[1].Lvl14Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

Level15(20);

end



process Level15(TotalSpirits);
private
int RemainingSpirits;
int Counter;
begin

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

Level=14;
LevelDone=0;
Points=0;
Cam_X=320; Cam_Y=240;

set_camera_pos(Cam_X,Cam_Y,80);
enable_culling(1);
enable3d(1);

LevelScroll(171,170,0,30);
LevelCheck(172,640,480,20);

write(0,3,3,0,"Score :");
write_int(0,50,3,0,&score);
write(0,210,3,0,"Remaining Happy Spirits :");
write_int(0,365,3,0,&RemainingSpirits);
write(0,575,3,0,"Lives :");
write_int(0,620,3,0,&lives);

delete_3dobject(Background3D);
Background3D=new_3dobject(2,0,0,0,1,1,1);
set_mesh(Background3D,Bkg3D12);
set_texture(Background3D,load_texture(0,188));
set_rot(Background3D,90,0,0);
x2=440; y2=160;

Point(353,266,929,690,4,1);
DrawBackground(320,240,2);

ConveyorRight(639,298,10);
ConveyorDown(848,478,10);
ConveyorLeft(639,658,10);
ConveyorUp(429,477,10);

SpinAlarm(-10,-10,1);
SpinAlarm(650,-10,1);

Boss5();

x=590; y=480;
scroll.camera=id;

FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,240,0,187,0,10,2);
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,69,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==50)
ZoomOut(320,240,0,67,0,10,2);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)
Counter=0;
repeat
  Counter++;
  if (x>380) x--; end
  if (y>290) y--; end
  frame(50);
until(Counter==110)

Player(380,290,4);
ScoreTimer();

Pause();

repeat
  RemainingSpirits=TotalSpirits-points;
  frame;
until(RemainingSpirits==0)
LevelDone=1;


if (Score>Saves[1].Lvl13Score)
  Saves[1].Lvl13Score=Score;
end
if (Score>Saves[1].HiScore)
  Saves[1].HiScore=Score;
  Saves[1].TopLevel=Level+1;
end
save("score.dat",Saves);
  
ZoomOut(320,240,1,9,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,240,1,2);
  Particle_Splash(320,240,1,2);
  Particle_Splash(420,240,1,2);
until(Counter==8)

signal (type ScoreTimer, s_sleep);
signal (type ScoreTimerBottom, s_sleep);

frame; frame; frame;
repeat frame; until(key(_space) or key(_enter))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

let_me_alone();
delete_text(0);

if (SingleLevel==1) SingleLevel=0; MainMenu(); end

WinGame();

end




process Player(x,y,z);
private
int X_Velocity;
int Y_Velocity;
int CollCheck;
int IdleCheck;
int MoveAnimation;
int IdleAnimation;
int Start_X;
int Start_Y;
int DelayCounter;
int Direction;
begin

if (Level==0) x2=440; y2=160; end
if (Level==1) x2=315; y2=238; end
if (Level==2) x2=440; y2=160; end
if (Level==3) x2=440; y2=160; end
if (Level==4) x2=440; y2=160; end
if (Level==5) x2=440; y2=160; end
if (Level==6) x2=440; y2=160; end
if (Level==7) x2=440; y2=160; end
if (Level==8) x2=440; y2=160; end
if (Level==9) x2=440; y2=160; end
if (Level==10) x2=440; y2=160; end
if (Level==11) x2=440; y2=160; end
if (Level==12) x2=440; y2=160; end
if (Level==13) x2=440; y2=160; end
if (Level==14) x2=440; y2=160; end

set_pos(Background3D,x2,y2,-80);

scroll.camera=id;
ctype=c_scroll;

Start_X=x;
Start_Y=y;
graph=15;
size=300;
InvincibleCounter=50;

repeat
  size-=5;
  frame(50);
until(size==100);
Shockwave(x,y,z+1,39);

loop

  if (key(_left))
    IdleCheck=0;
    x-=7;
    if (collision(type SlowDownWorldObject)) x+=3; end frame(0);
    if (rand(1,4)==1 and Level==3 or Level==4 or Level==5) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==6 or Level==7 or Level==8) Particle_Trail(x+2,y,z+1,1,2); end
    if (rand(1,4)==1 and Level==9 and x<650) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==9 and x>650) Particle_Trail2(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==10 and y<480) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==10 and y>480) Particle_Trail2(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==11 and x<650) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==11 and x>650) Particle_Trail2(x+2,y,z+1,1,1); end
  end
  if (key(_right))
    IdleCheck=0;
    x+=7;
    if (collision(type SlowDownWorldObject)) x-=3; end frame(0);
    if (rand(1,4)==1 and Level==3 or Level==4 or Level==5) Particle_Trail(x-2,y,z+1,5,1); end
    if (rand(1,4)==1 and Level==6 or Level==7 or Level==8) Particle_Trail(x+2,y,z+1,5,2); end
    if (rand(1,4)==1 and Level==9 and x<650) Particle_Trail(x+2,y,z+1,5,1); end
    if (rand(1,4)==1 and Level==9 and x>650) Particle_Trail2(x+2,y,z+1,5,1); end
    if (rand(1,4)==1 and Level==10 and y<480) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==10 and y>480) Particle_Trail2(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==11 and x<650) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==11 and x>650) Particle_Trail2(x+2,y,z+1,1,1); end
  end
  if (key(_up))
    IdleCheck=0;
    y-=7;
    if (collision(type SlowDownWorldObject)) y+=3; end frame(0);
    if (rand(1,4)==1 and Level==3 or Level==4 or Level==5) Particle_Trail(x,y+2,z+1,3,1); end
    if (rand(1,4)==1 and Level==6 or Level==7 or Level==8) Particle_Trail(x+2,y,z+1,3,2); end
    if (rand(1,4)==1 and Level==9 and x<650) Particle_Trail(x+2,y,z+1,3,1); end
    if (rand(1,4)==1 and Level==9 and x>650) Particle_Trail2(x+2,y,z+1,3,1); end
    if (rand(1,4)==1 and Level==10 and y<480) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==10 and y>480) Particle_Trail2(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==11 and x<650) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==11 and x>650) Particle_Trail2(x+2,y,z+1,1,1); end
  end
  if (key(_down))
    IdleCheck=0;
    y+=7;
    if (collision(type SlowDownWorldObject)) y-=3; end frame(0);
    if (rand(1,4)==1 and Level==3 or Level==4 or Level==5) Particle_Trail(x,y-2,z+1,7,1); end
    if (rand(1,4)==1 and Level==6 or Level==7 or Level==8) Particle_Trail(x+2,y,z+1,7,2); end
    if (rand(1,4)==1 and Level==9 and x<650) Particle_Trail(x+2,y,z+1,7,1); end
    if (rand(1,4)==1 and Level==9 and x>650) Particle_Trail2(x+2,y,z+1,7,1); end
    if (rand(1,4)==1 and Level==10 and y<480) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==10 and y>480) Particle_Trail2(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==11 and x<650) Particle_Trail(x+2,y,z+1,1,1); end
    if (rand(1,4)==1 and Level==11 and x>650) Particle_Trail2(x+2,y,z+1,1,1); end
  end

  if (collision(type ConveyorRight)) x+=2; x2-=1.02; end frame(0);
  if (collision(type ConveyorLeft)) x-=2; x2+=1.02; end frame(0);
  if (collision(type ConveyorUp)) y-=2; y2-=1.02; end frame(0);
  if (collision(type ConveyorDown)) y+=2; y2+=1.02; end frame(0);
  
  if (key(_left))
    x2+=3.57;
    if (collision(type SlowDownWorldObject)) x2-=1.53; end frame(0);
  end
  if (key(_right))
    x2-=3.57;
    if (collision(type SlowDownWorldObject)) x2+=1.53; end frame(0);
  end
  if (key(_up))
    y2-=3.57;
    if (collision(type SlowDownWorldObject)) y2+=1.53; end frame(0);
  end
  if (key(_down))
    y2+=3.57;
    if (collision(type SlowDownWorldObject)) y2-=1.53; end frame(0);
  end

  if (collision(type LevelCheck))
    if (key(_left)) x+=7; end
    if (key(_right)) x-=7; end
    if (key(_up)) y+=7; end
    if (key(_down)) y-=7; end

    if (key(_left)) x2-=3.57; end
    if (key(_right)) x2+=3.57; end
    if (key(_up)) y2+=3.57; end
    if (key(_down)) y2-=3.57; end
  end

  if (WindOn==1)
    x+=2;
    x2-=1.02;
    frame(0);
    if (collision(type LevelCheck)) x--; x2+=1.02; end
  end

  set_pos(Background3D,x2,y2,-80);

  Player_X=x;
  Player_Y=y;

  MoveAnimation++;
  if (EnemyClose==0)
    if (MoveAnimation==1 or MoveAnimation==2) graph=15; end
    if (MoveAnimation==3 or MoveAnimation==4) graph=40; end
    if (MoveAnimation==5 or MoveAnimation==6) graph=41; end
    if (MoveAnimation==7 or MoveAnimation==8) graph=40; end
    if (MoveAnimation=>9) MoveAnimation=0; end
  end
  if (EnemyClose==1)
    if (MoveAnimation==1 or MoveAnimation==2) graph=56; end
    if (MoveAnimation==3 or MoveAnimation==4) graph=57; end
    if (MoveAnimation==5 or MoveAnimation==6) graph=58; end
    if (MoveAnimation==7 or MoveAnimation==8) graph=57; end
    if (MoveAnimation=>9) MoveAnimation=0; EnemyClose=0; end
  end

   
  if (IdleCheck<30) IdleCheck++; IdleAnimation=0; end
  if (IdleCheck==26 or IdleCheck==27 or IdleCheck==28 or IdleCheck==29) graph=59; end
  if (IdleCheck==30) IdleAnimation++; end
  if (IdleAnimation==1 or IdleAnimation==2 or IdleAnimation==3 or IdleAnimation==4) graph=60; end
  if (IdleAnimation==5 or IdleAnimation==6 or IdleAnimation==7 or IdleAnimation==8) graph=61; end
  if (IdleAnimation==9 or IdleAnimation==10 or IdleAnimation==11 or IdleAnimation==12) graph=62; end
  if (IdleAnimation==13 or IdleAnimation==14 or IdleAnimation==15 or IdleAnimation==16) graph=61; end
  if (IdleAnimation==16) IdleAnimation=0; end

  if (InvincibleCounter>0)
    InvincibleCounter--;
    alpha=100;
    if (InvincibleCounter==0) alpha=255; end
  end
  
  if (InvincibleCounter==0)

    if (collision(type BoxEnemy) or collision(type Boss1) or collision(type Boss3) or collision(type Enemy_Fish) or collision(type Boss4Part1) or collision(type Boss4Part2) or collision(type Boss4Part3) or collision(type Shockwave2) or collision(type InkBullet) or collision(type Bees) or collision(type Enemy_Snake))
      if (Lives>0) Lives--; end
      if (Lives==0) GameOver(); end  
      z++;
      DelayCounter=0;
      repeat
        size-=4;
        DelayCounter++;
        frame;
      until(DelayCounter==20)
      CreateSparks(x,y,z,200,20,3,7,1);
      play_wav(Poff,0);
      DelayCounter=0; repeat DelayCounter++; frame; until(DelayCounter==10)
      graph=0;
      Player(Start_X,Start_Y,z);
      return;
    end

    if (collision(type Boss2) and Boss2DamageOn==1)
      if (Lives>0) Lives--; end
      if (Lives==0) GameOver(); end  
      z++;
      DelayCounter=0;
      repeat
        size-=4;
        DelayCounter++;
        frame;
      until(DelayCounter==20)
      CreateSparks(x,y,z,200,20,3,7,1);
      play_wav(Poff,0);
      DelayCounter=0; repeat DelayCounter++; frame; until(DelayCounter==10)
      graph=0;
      Player(Start_X,Start_Y,z);
      return;
    end

    if (collision(type SparkEnemy) or collision(type Laser) or collision(type Beam))
      if (Lives>0) Lives--; end
      if (Lives==0) GameOver(); end  
      DelayCounter=0;
      play_wav(Zap,0);
      repeat
        graph=191;
        frame; frame;
        graph=192;
        frame; frame;
        CreateSparks(x,y,z,200,4,3,7,4);
        DelayCounter++;
      until(DelayCounter==6)
      graph=193; frame; frame; frame;
      graph=194; frame; frame; frame;
      graph=195; frame; frame; frame;
      graph=196; frame; frame; frame;
      graph=197; frame; frame; frame;
      graph=198; frame; frame; frame;
      play_wav(Poff,0);
      DelayCounter=0; repeat DelayCounter++; frame; until(DelayCounter==10)
      graph=0;
      Player(Start_X,Start_Y,z);
      return;
    end
  
  end  
  
  if (LevelDone==1)
    repeat
      alpha-=10;
      frame;
    until (alpha<0)  
    return;
  end

  frame;
end
end



process BoxEnemy(Min_X,Min_Y,Max_X,Max_Y,z,Model,Direction);
private
int Counter;
begin
graph=17;
size=200;
ctype=c_scroll;
Shockwave(x,y,2,39);

repeat
  x=rand(Min_X,Max_X);
  y=rand(Min_Y,Max_Y);
  frame(0);
until(collision(type LevelCheck)==0 and collision(type NoEnemyArea)==0 and collision(type BoxEnemy)==0 and collision(type Player)==0)

loop
  if (Model==1)
    if (Direction==1) x-=1; Counter++; end
    if (Direction==2) x+=1; Counter++; end
    if (Direction==1)
      if (Counter==1) graph=27; end
      if (Counter==2) graph=28; end
      if (Counter==3) graph=29; end
      if (Counter==4) graph=30; end
      if (Counter==5) graph=31; end
      if (Counter==6) graph=32; end
      if (Counter==7) graph=33; end
      if (Counter==8) graph=34; end
      if (Counter==9) graph=35; end
      if (Counter==10) graph=36; end  
    end
    if (Direction==2)
      if (Counter==10) graph=27; end
      if (Counter==9) graph=28; end
      if (Counter==8) graph=29; end
      if (Counter==7) graph=30; end
      if (Counter==6) graph=31; end
      if (Counter==5) graph=32; end
      if (Counter==4) graph=33; end
      if (Counter==3) graph=34; end
      if (Counter==2) graph=35; end
      if (Counter==1) graph=36; end  
    end    
    if (Counter==11) Counter=1; end
    if (Direction==1 and collision(type LevelCheck)) Direction=2;
    elseif (Direction==2 and collision(type LevelCheck)) Direction=1; end      
  end
  
  if (Model==2)
    if (Direction==1) y-=1; Counter++; end
    if (Direction==2) y+=1; Counter++; end
    if (Direction==1)
      flags=2;
      if (Counter==1) graph=17; end
      if (Counter==2) graph=18; end
      if (Counter==3) graph=19; end
      if (Counter==4) graph=20; end
      if (Counter==5) graph=21; end
      if (Counter==6) graph=22; end
      if (Counter==7) graph=23; end
      if (Counter==8) graph=24; end
      if (Counter==9) graph=25; end
      if (Counter==10) graph=26; end  
    end
    if (Direction==2)
      flags=2;
      if (Counter==10) graph=17; end
      if (Counter==9) graph=18; end
      if (Counter==8) graph=19; end
      if (Counter==7) graph=20; end
      if (Counter==6) graph=21; end
      if (Counter==5) graph=22; end
      if (Counter==4) graph=23; end
      if (Counter==3) graph=24; end
      if (Counter==2) graph=25; end
      if (Counter==1) graph=26; end  
    end    
    if (Counter==11) Counter=1; end
    if (Direction==1 and collision(type LevelCheck)) Direction=2;
    elseif (Direction==2 and collision(type LevelCheck)) Direction=1; end      
  end

  if (fget_dist(x,y,Player_X,Player_Y)<100) EnemyClose=1; end

  frame(50);
end
end



process Enemy_Fish(x,y,z,Mode);
private
int Velocity;
int Direction;
begin
graph=156;
alpha=100;
ctype=c_scroll;
Direction=rand(1,2);

if (Mode==1)
  loop
    if (rand(1,20)==1) Velocity=10; end

    if (Direction==1) y-=Velocity; flags=0; end
    if (Direction==2) y+=Velocity; flags=2; end
  
    if (Velocity>0) Velocity--; end
    if (Direction==1 and collision(type LevelCheck)) y+=Velocity; Direction=2;
    elseif (Direction==2 and collision(type LevelCheck)) y-=Velocity; Direction=1; end      

    if (fget_dist(x,y,Player_X,Player_Y)<100) EnemyClose=1; end
    frame;
  end
end

if (Mode==2)
  angle=90000;
  loop
    if (rand(1,20)==1) Velocity=10; end

    if (Direction==1) x-=Velocity; flags=1; end
    if (Direction==2) x+=Velocity; flags=2; end
  
    if (Velocity>0) Velocity--; end
    if (Direction==1 and collision(type LevelCheck)) x+=Velocity; Direction=2;
    elseif (Direction==2 and collision(type LevelCheck)) x-=Velocity; Direction=1; end

    if (fget_dist(x,y,Player_X,Player_Y)<100) EnemyClose=1; end
    frame;
  end
end

end



process Enemy_Snake(x,y,z);
private
int Velocity;
int Direction;
begin
graph=217;
ctype=c_scroll;
Direction=rand(1,2);

loop
  if (rand(1,20)==1) Velocity=10; end
  if (Velocity==10 or Velocity==8 or Velocity==6 or Velocity==4 or Velocity==2)
    if (flags==2) flags=3; end
    if (flags==0) flags=1; end
  end
  if (Velocity==9 or Velocity==7 or Velocity==5 or Velocity==3 or Velocity==1)
    if (flags==3) flags=2; end
    if (flags==1) flags=0; end
  end  
  
  frame;
  
  if (Direction==1) y-=Velocity; flags=2; end
  if (Direction==2) y+=Velocity; flags=0; end
  
  if (Velocity>0) Velocity--; end
  if (Direction==1 and collision(type LevelCheck)) y+=Velocity; Direction=2;
  elseif (Direction==2 and collision(type LevelCheck)) y-=Velocity; Direction=1; end      

  if (fget_dist(x,y,Player_X,Player_Y)<100) EnemyClose=1; end
end
end



process DrawBackground(x,y,z);
begin
graph=BackgroundMap;
loop frame; end
end


process LevelScroll(Gfx,Gfx2,Gfx3,z);
begin
if (Gfx2>0) start_scroll(0,0,Gfx,Gfx2,0,0); end
if (Gfx2==0) start_scroll(0,0,Gfx,0,0,0); end
Scroll[0].z=z;
x=320;
y=240;
z=258;
graph=Gfx3;
loop
  frame;
end
end

process LevelCheck(graph,x,y,z);
begin
ctype=c_scroll;
loop
  frame;
end
end


process DisplayWorldObject(x,y,z,graph,size,Mode);
begin
ctype=c_scroll;
loop frame; end
end


process DisplayScreenObject(x,y,z,graph,size,Mode);
private
int Counter;
begin
if (Mode==2) alpha=150; end
loop frame; end
end


process Shockwave(x,y,z,graph);
begin
ctype=c_scroll;
alpha=200;
size=0;
repeat
  size+=20;
  alpha-=20;
  frame;
until (alpha==0);
end


process Shockwave2(x,y,z,graph);
begin
ctype=c_scroll;
alpha=200;
size=0;
repeat
  size+=20;
  alpha-=20;
  frame;
until (alpha==0);
end



process Point(Min_X,Min_Y,Max_X,Max_Y,z,Mode);
private
int Counter;

begin
ctype=c_scroll;
graph=7;

repeat
  x=rand(Min_X,Max_X);
  y=rand(Min_Y,Max_Y);
  frame(0);
until(collision(type LevelCheck)==0)

Shockwave(x,y,z,39);
repeat
  if (fget_dist(x,y,Player_X,Player_Y)<150) graph=37; end
  if (fget_dist(x,y,Player_X,Player_Y)>150) graph=7; end  
  frame;
until(collision(type Player))
play_wav(Pop,0);
Score+=ScoreCounter;
ScoreCounter=640;
InvincibleCounter=30;
repeat
  Counter++;
  Particle_Splash(x,y,z,1);
until(Counter==10)
Shockwave(x,y,z,39);

Points++;

if (Level==0)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==1)
  Point(320,240,960,720,4,1);
  if (Mode==1) BoxEnemy(320,240,960,720,3,rand(1,2),rand(1,2)); end
end
if (Level==2) Point(320,240,960,720,4,1); end
if (Level==3)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==4)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==5) Point(320,240,960,720,4,1); end
if (Level==6)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==7)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==8) Point(353,266,929,690,4,1); end
if (Level==9)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==10)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==11) Point(353,266,929,640,4,1); end
if (Level==12)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==13)
  Point(353,266,929,690,4,1);
  if (Mode==1) BoxEnemy(353,266,929,690,3,rand(1,2),rand(1,2)); end
end
if (Level==14) Point(353,266,929,640,4,1); end

graph=38;
repeat
  y-=2;
  alpha-=10;
  frame;
until (alpha<0)

end


process CreateSparks(x,y,z,alpha,Amount,Velocity,StartVelocity,Model);
private
int Counter;
begin
Counter=0;
repeat
  Counter++;
  Spark(x,y,z,alpha,Velocity,StartVelocity,Model);
until (Counter==Amount)
end



process Spark(x,y,z,alpha,Velocity,EntryVelocity,Model);
private
int Counter;
int Direction;
int Gravity;
begin
if (Model==1 or Model==2 or Model==3 or Model==4 or Model==5) ctype=c_scroll; end
if (Model==0 or Model==1) graph=50+rand(0,2); end
if (Model==2) graph=135; end
if (Model==3) graph=142; end
if (Model==4) graph=189+rand(0,1); end
if (Model==5) graph=208+rand(0,1); end

Direction=rand(1,8);
repeat    
  if (Direction==1) x-=Velocity; end
  if (Direction==2) x-=Velocity; y-=Velocity; end
  if (Direction==3) y-=Velocity; end
  if (Direction==4) x+=Velocity; y-=Velocity; end
  if (Direction==5) x+=Velocity; end
  if (Direction==6) x+=Velocity; y+=Velocity; end
  if (Direction==7) y+=Velocity; end
  if (Direction==8) x-=Velocity; y+=Velocity; end
  
  x+=rand(-3,3);
  y+=rand(-3,3);
  alpha-=8;
  if (EntryVelocity<Velocity) Velocity--; end
  frame;
until (alpha<20)
end



process Particle_Trail(x,y,z,Direction,Mode);
private
int Speed;
int Rotation;
begin
ctype=c_scroll;
if (Mode==1) alpha=100; end
if (Mode==2) alpha=200; end
if (Mode==1 or Mode==2) flags=rand(0,3); end
if (Mode==2) graph=142; end
Speed=rand(1,3);
if (Mode==2) Rotation=rand(1,2); end
repeat
  if (Direction==1) x-=Speed; end
  if (Direction==2) x-=Speed; y-=Speed; end
  if (Direction==3) y-=Speed; end
  if (Direction==4) x+=Speed; y-=Speed; end
  if (Direction==5) x+=Speed; end
  if (Direction==6) x+=Speed; y+=Speed; end
  if (Direction==7) y+=Speed; end
  if (Direction==8) x-=Speed; y+=Speed; end
  if (Mode==1) alpha=alpha-10; end
  if (Mode==2) alpha=alpha-20; end
  x+=rand(-2,2);
  y+=rand(-2,2);
  if (Mode==1)
    if (alpha>120 and alpha<150) graph=131; end
    if (alpha>80 and alpha<120) graph=132; end
    if (alpha>40 and alpha<80) graph=133; end
    if (alpha>0 and alpha<40) graph=134; end
  end
  if (Mode==2)
    if (Rotation==1) angle+=3000; end
    if (Rotation==2) angle-=3000; end
  end
  frame;
until (alpha==20)
end



process Particle_Trail2(x,y,z,Direction,Mode);
private
int Speed;
int Rotation;
begin
ctype=c_scroll;
if (Mode==1) graph=158; alpha=200; end
repeat
  if (Direction==1) x-=Speed; end
  if (Direction==2) x-=Speed; y-=Speed; end
  if (Direction==3) y-=Speed; end
  if (Direction==4) x+=Speed; y-=Speed; end
  if (Direction==5) x+=Speed; end
  if (Direction==6) x+=Speed; y+=Speed; end
  if (Direction==7) y+=Speed; end
  if (Direction==8) x-=Speed; y+=Speed; end
  alpha=alpha-10;
  size+=5;
  frame;
until (alpha==20)
end





process Particle_Splash(x,y,z,Mode)
private
int Speed;
int DownSpeed;
int Direction;
begin
if (Mode==1) ctype=c_scroll; end
if (Mode==1) graph=53; end
if (Mode==2) graph=66; end
if (Mode==3) graph=80; end
if (Mode==4) graph=81; end
if (Mode==5) graph=82; end
DownSpeed=rand(-12,-4);
Direction=rand(1,2);
if (Direction==1) Speed=rand(1,3); end
if (Direction==2) Speed=rand(-3,-1); end
repeat
  x+=Speed;
  y+=DownSpeed;
  if (DownSpeed<5) DownSpeed++; end
  alpha-=10;
  if (Direction==1) angle-=5000; end
  if (Direction==2) angle+=5000; end
  frame;
until(alpha<0)
end


process ScoreTimer();
begin
graph=54;
x=320;
y=470;
z=0;
ScoreTimerBottom(x,y,z+1);
alpha=200;
loop
  if (ScoreCounter>0) ScoreCounter--; end
  x=ScoreCounter-320;
  frame;
end
end


process ScoreTimerBottom(x,y,z);
begin
graph=55;
loop frame; end
end


process NoEnemyArea(x,y,z,graph);
begin
ctype=c_scroll;
loop frame; end
end


process ZoomOut(x,y,z,graph,size,Speed,Mode);
begin
if (Mode==1 or Mode==2)
  repeat
    size+=Speed;
    frame;
  until (size==100);
end
if (Mode==3)
  repeat
    size+=Speed;
    frame;
  until (size==200);
end
if (Mode==1 or Mode==3)
  loop frame; end
end
if (Mode==2)
  frame; frame; frame; frame; frame;
  repeat
    alpha-=10;
    frame(50);
  until(alpha<0)
end
if (Mode==4)
  ctype=c_scroll;
  size=0;
  repeat
    x+=rand(-4,4);
    y+=rand(-4,4);
    size+=5;
    alpha-=5;
    frame(50);
  until(alpha<0)
end


end


process SmallBallAnimation1(x,y,z,Range);
private
int Counter;
int MoveAnimation;
begin
repeat
  Counter++;
  MoveAnimation++;
  if (MoveAnimation==1 or MoveAnimation==2) graph=15; end
  if (MoveAnimation==3 or MoveAnimation==4) graph=40; end
  if (MoveAnimation==5 or MoveAnimation==6) graph=41; end
  if (MoveAnimation==7 or MoveAnimation==8) graph=40; end
  if (MoveAnimation=>9) MoveAnimation=0; end
  x+=4;
  frame;
until(Counter==Range)
end



process SmallBallAnimation2(x,y,z,Range);
private
int Counter;
int MoveAnimation;
int IdleCheck;
int IdleAnimation;
begin
repeat
  Counter++;
  MoveAnimation++;
  if (MoveAnimation==1 or MoveAnimation==2) graph=15; end
  if (MoveAnimation==3 or MoveAnimation==4) graph=40; end
  if (MoveAnimation==5 or MoveAnimation==6) graph=41; end
  if (MoveAnimation==7 or MoveAnimation==8) graph=40; end
  if (MoveAnimation=>9) MoveAnimation=0; end
  x+=4;
  frame;
until(Counter==Range)
loop
  if (IdleCheck<30) IdleCheck++; IdleAnimation=0; end
  if (IdleCheck==26 or IdleCheck==27 or IdleCheck==28 or IdleCheck==29) graph=59; end
  if (IdleCheck==30) IdleAnimation++; end
  if (IdleAnimation==1 or IdleAnimation==2 or IdleAnimation==3 or IdleAnimation==4) graph=60; end
  if (IdleAnimation==5 or IdleAnimation==6 or IdleAnimation==7 or IdleAnimation==8) graph=61; end
  if (IdleAnimation==9 or IdleAnimation==10 or IdleAnimation==11 or IdleAnimation==12) graph=62; end
  if (IdleAnimation==13 or IdleAnimation==14 or IdleAnimation==15 or IdleAnimation==16) graph=61; end
  if (IdleAnimation==16) IdleAnimation=0; end
  frame;
end
end



process SmallBallAnimation3(x,y,z,Range);
private
int Counter;
int MoveAnimation;
int IdleAnimation;
begin
repeat
  Counter++;
  MoveAnimation++;
  if (MoveAnimation==1 or MoveAnimation==2) graph=15; end
  if (MoveAnimation==3 or MoveAnimation==4) graph=40; end
  if (MoveAnimation==5 or MoveAnimation==6) graph=41; end
  if (MoveAnimation==7 or MoveAnimation==8) graph=40; end
  if (MoveAnimation=>9) MoveAnimation=0; end
  x+=4;
  frame;
until(Counter==Range)
loop
  IdleAnimation++;
  if (IdleAnimation==1 or IdleAnimation==2 or IdleAnimation==3 or IdleAnimation==4) graph=15; end
  if (IdleAnimation==5 or IdleAnimation==6 or IdleAnimation==7 or IdleAnimation==8) graph=40; end
  if (IdleAnimation==9 or IdleAnimation==10 or IdleAnimation==11 or IdleAnimation==12) graph=41; end
  if (IdleAnimation==13 or IdleAnimation==14 or IdleAnimation==15 or IdleAnimation==16) graph=40; end
  if (IdleAnimation==16) IdleAnimation=0; end
  frame;
end
end



process FadeIn(graph);
begin
x=320;
y=240;
z=0;
alpha=0;
repeat
  alpha+=5;
  frame(25);
until(alpha>255)
loop frame; end
end


process FadeOut(graph);
begin
x=320;
y=240;
z=0;
alpha=255;
repeat
  alpha-=5;
  frame(25);
until(alpha<0)
end


process Boss1(x,y,z,Mode);
private
int Direction;
begin
Boss1Shadow(x,y,z+1);
ctype=c_scroll;
graph=76;
Direction=rand(1,4);

loop
  if (Direction==1) x+=4; y+=4; end
  if (Direction==2) x-=4; y+=4; end
  if (Direction==3) x-=4; y-=4; end
  if (Direction==4) x+=4; y-=4; end
  
  if (x>844 and collision(type LevelCheck) and Direction==1) Direction=2; play_wav(Bounce,0); end frame(0);
  if (y>604 and collision(type LevelCheck) and Direction==1) Direction=4; play_wav(Bounce,0); end frame(0);
  if (x>844 and collision(type LevelCheck) and Direction==4) Direction=3; play_wav(Bounce,0); end frame(0);
  if (y>604 and collision(type LevelCheck) and Direction==2) Direction=3; play_wav(Bounce,0); end frame(0);  
  
  if (x<439 and collision(type LevelCheck) and Direction==2) Direction=1; play_wav(Bounce,0); end frame(0);
  if (y<352 and collision(type LevelCheck) and Direction==4) Direction=1; play_wav(Bounce,0); end frame(0);
  if (x<439 and collision(type LevelCheck) and Direction==3) Direction=4; play_wav(Bounce,0); end frame(0);
  if (y<352 and collision(type LevelCheck) and Direction==3) Direction=2; play_wav(Bounce,0); end frame(0);   

  angle+=5000;
  if (angle==360000) angle=0; end
  
  size=100+(Points*10);
  
  frame;
  
  Boss_X=x;
  Boss_Y=y;
  
end
end


process Boss1Shadow(x,y,z);
begin
ctype=c_scroll;
graph=77;
alpha=100;
loop
  x=Boss_X;
  y=Boss_Y;

  angle+=5000;
  if (angle==360000) angle=0; end
  size=100+(Points*10);
  
  frame;
end
end



process Boss2(x,y,z,Mode);
private
int Direction;
int Counter;
int SizeIncrease;
begin

ctype=c_scroll;
graph=130;
Direction=rand(1,4);

loop

  Counter++;
  if (Counter==1) alpha=0; size=100+(Points*10); end
  if (Counter>1 and Counter<100)
    if (Counter==2) play_wav(Earth,0); end
    ZoomOut(x,y,z-1,127,0,0,4);

    if (Direction==1) x+=4; y+=4; end
    if (Direction==2) x-=4; y+=4; end
    if (Direction==3) x-=4; y-=4; end
    if (Direction==4) x+=4; y-=4; end
  
    if (x>844 and collision(type LevelCheck) and Direction==1) Direction=2; end frame(0);
    if (y>604 and collision(type LevelCheck) and Direction==1) Direction=4; end frame(0);
    if (x>844 and collision(type LevelCheck) and Direction==4) Direction=3; end frame(0);
    if (y>604 and collision(type LevelCheck) and Direction==2) Direction=3; end frame(0);
  
    if (x<439 and collision(type LevelCheck) and Direction==2) Direction=1; end frame(0);
    if (y<352 and collision(type LevelCheck) and Direction==4) Direction=1; end frame(0);
    if (x<439 and collision(type LevelCheck) and Direction==3) Direction=4; end frame(0);
    if (y<352 and collision(type LevelCheck) and Direction==3) Direction=2; end frame(0);
  end


  if (Counter==99) size=0; end
  if (Counter>100 and Counter<150)
    if (Counter==101) play_wav(Rocks,0); end
    Boss2DamageOn=1;
    alpha+=5;
    SizeIncrease+=2;
    size=SizeIncrease+(Points*10);

    if (rand(1,2)==1) CreateSparks(x+rand(-10,10),y+rand(-10,10),z-1,200,20,rand(2,4),rand(6,8),2); end
    if (rand(1,2)==1) ZoomOut(x+rand(-10,10),y+rand(-10,10),z-1,127,0,0,4); end

    angle+=5000;
    if (angle==360000) angle=0; end
    
  end
  

  if (Counter>150 and Counter<200)
    if (Counter==151) play_wav(Rocks,0); end
    alpha+=5;
    SizeIncrease-=2;
    size=SizeIncrease+(Points*10);

    if (rand(1,2)==1) CreateSparks(x+rand(-10,10),y+rand(-10,10),z-1,200,20,rand(2,4),rand(6,8),2); end
    if (rand(1,2)==1) ZoomOut(x+rand(-10,10),y+rand(-10,10),z-1,127,0,0,4); end

    angle+=5000;
    if (angle==360000) angle=0; end
    
  end

  if (Counter==201) Boss2DamageOn=0; Counter=0; end
  
  frame;
  
  Boss_X=x;
  Boss_Y=y;
  
end
end



process Boss3();
private
int Direction;
int Counter;
begin

z=3;

Boss3_Shadow();

ctype=c_scroll;
graph=150;
Direction=rand(1,8);

if (Direction==1) x=-500; y=300; angle=0; flags=0; play_wav(Snake,0); end
if (Direction==2) x=-500; y=600; angle=0; flags=0; play_wav(Snake,0); end
if (Direction==3) x=400; y=-500; angle=270000; flags=0; play_wav(Snake,0); end
if (Direction==4) x=800; y=-500; angle=270000; flags=0; play_wav(Snake,0); end
if (Direction==5) x=1780; y=300; angle=0; flags=1; play_wav(Snake,0); end
if (Direction==6) x=1780; y=600; angle=0; flags=1; play_wav(Snake,0); end
if (Direction==7) x=400; y=980; angle=90000; flags=0; play_wav(Snake,0); end
if (Direction==8) x=800; y=980; angle=90000; flags=0; play_wav(Snake,0); end

loop

  if (Direction==1)
    x+=10;
    if (rand(1,3)==1) CreateSparks(x+220+rand(-10,10),y+rand(-10,10),z+2,200,20,rand(2,4),rand(6,8),3); end
  end
  if (Direction==2)
    x+=10;
    if (rand(1,3)==1) CreateSparks(x+220+rand(-10,10),y+rand(-10,10),z+2,200,20,rand(2,4),rand(6,8),3); end
  end
  if (Direction==3)
    y+=10;
    if (rand(1,3)==1) CreateSparks(x+rand(-10,10),y+220+rand(-10,10),z+2,200,20,rand(2,4),rand(6,8),3); end
  end
  if (Direction==4)
    y+=10;
    if (rand(1,3)==1) CreateSparks(x+rand(-10,10),y+220+rand(-10,10),z+2,200,20,rand(2,4),rand(6,8),3); end
  end
  if (Direction==5)
    x-=10;
    if (rand(1,3)==1) CreateSparks(x-220+rand(-10,10),y+rand(-10,10),z+2,200,20,rand(2,4),rand(6,8),3); end
  end
  if (Direction==6)
    x-=10;
    if (rand(1,3)==1) CreateSparks(x-220+rand(-10,10),y+rand(-10,10),z+2,200,20,rand(2,4),rand(6,8),3); end
  end
  if (Direction==7)
    y-=10;
    if (rand(1,3)==1) CreateSparks(x+rand(-10,10),y-220+rand(-10,10),z+2,200,20,rand(2,4),rand(6,8),3); end
  end
  if (Direction==8)
    y-=10;
    if (rand(1,3)==1) CreateSparks(x+rand(-10,10),y-220+rand(-10,10),z+2,200,20,rand(2,4),rand(6,8),3); end
  end

  if (x>1780 or x<-510 or y>1460 or y<-510)
    Direction=rand(1,8);
    if (Direction==1) x=-500; y=300; angle=0; flags=0; play_wav(Snake,0); end
    if (Direction==2) x=-500; y=600; angle=0; flags=0; play_wav(Snake,0); end
    if (Direction==3) x=400; y=-500; angle=270000; flags=0; play_wav(Snake,0); end
    if (Direction==4) x=800; y=-500; angle=270000; flags=0; play_wav(Snake,0); end
    if (Direction==5) x=1780; y=300; flags=1; angle=0; play_wav(Snake,0); end
    if (Direction==6) x=1780; y=600; flags=1; angle=0; play_wav(Snake,0); end
    if (Direction==7) x=400; y=980; angle=90000; flags=0; play_wav(Snake,0); end
    if (Direction==8) x=800; y=980; angle=90000; flags=0; play_wav(Snake,0); end  
  end

  Counter++;
  if (Counter>0 and Counter<10)
    if (Direction==1) y+=1; end
    if (Direction==2) y+=1; end
    if (Direction==3) x+=1; end
    if (Direction==4) x+=1; end
    if (Direction==5) y+=1; end
    if (Direction==6) y+=1; end
    if (Direction==7) x+=1; end
    if (Direction==8) x+=1; end
  end
  if (Counter>10 and Counter<20)
    if (Direction==1) y-=1; end
    if (Direction==2) y-=1; end
    if (Direction==3) x-=1; end
    if (Direction==4) x-=1; end
    if (Direction==5) y-=1; end
    if (Direction==6) y-=1; end
    if (Direction==7) x-=1; end
    if (Direction==8) x-=1; end
  end
  if (Counter==21) Counter=0; end
  
  Boss3_X=x;
  Boss3_Y=y;
  Boss3_Angle=angle;
  
  size=100+(Points*10);
  frame;
end

end



process Boss3_Shadow();
begin
ctype=c_scroll;
graph=150;
alpha=100;
z=6;
size=90;
loop
  x=Boss3_X+10;
  y=Boss3_Y+10;
  angle=Boss3_Angle;
  frame;
end
end


process Boss4();
begin

Boss4Part1(960,480,7,1);
Boss4Part1(960,480,7,2);
Boss4Part2(960,480,6);
Boss4Part3(960,480,5);

end


process Boss4Part1(x,y,z,Mode);
private
int Counter;
int Counter2;
begin
ctype=c_scroll;
graph=165;
if (Mode==2) flags=2; end
loop
  Counter++;
  if (Counter>80 and Counter<160) y-=2; end
  if (Counter>160 and Counter<320) y+=2; end
  if (Counter>320 and Counter<400) y-=2; end
  if (Counter>400 and Counter<500)
    if (Mode==1) angle+=900; end
    if (Mode==2) angle-=900; end
  end
  if (Counter>500 and Counter<600)
    if (Mode==1) angle-=900; end
    if (Mode==2) angle+=900; end
  end
  if (Counter==700) Counter=0; end

  Counter2++;
  if (Counter2>0 and Counter2<20) size+=1; end
  if (Counter2>20 and Counter2<40) size-=1; end
  if (Counter2==41) Counter2=0; end

  frame(50);
end
end



process Boss4Part2(x,y,z);
private
int Counter;
int Counter2;
int Counter3;
begin
ctype=c_scroll;
graph=166;
Counter2=10;
loop
  Counter++;
  if (Counter>80 and Counter<160)
    y-=2;
    if (Counter3==40) InkBullet(x-60,y,z); end
  end
  if (Counter>160 and Counter<320)
    y+=2;
    if (Counter3==40) InkBullet(x-60,y,z); end
  end
  if (Counter>320 and Counter<400)
    y-=2;
    if (Counter3==40) InkBullet(x-60,y,z); end
  end
  if (Counter==700) Counter=0; end

  Counter2++;
  if (Counter2>0 and Counter2<10) size+=1; end
  if (Counter2>10 and Counter2<20) size-=1; end
  if (Counter2==21) Counter2=0; end

  Counter3++;
  if (Counter3==41) Counter3=0; end

  frame(50);
end
end



process Boss4Part3(x,y,z);
private
int Counter;
int Counter2;
int Counter3;
begin
ctype=c_scroll;
graph=167;
angle-=15000;
Counter2=10;
loop
  Counter++;
  if (Counter>80 and Counter<160) y-=2; end
  if (Counter>160 and Counter<320) y+=2; end
  if (Counter>320 and Counter<400) y-=2; end
  if (Counter==700) Counter=0; end

  Counter2++;
  if (Counter2>0 and Counter2<10) size+=1; end
  if (Counter2>10 and Counter2<20) size-=1; end
  if (Counter2==21) Counter2=0; end

  Counter3++;
  if (Counter3>0 and Counter3<30) angle+=2000; end
  if (Counter3>30 and Counter3<60) angle-=2000; end
  if (Counter3==61) Counter3=0; end

  frame(50);
end
end


process InkBullet(x,y,z);
begin
ctype=c_scroll;
graph=168;
size=0;
alpha=150;
play_wav(Splash,0);
repeat
  x-=10;
  size+=10;
  frame(50);
  angle+=5000;
until(size==100)
repeat
  x-=10;
  InkBulletFade(x-5,y+rand(-5,5),z+1);
  angle+=5000;
  frame;
until(x<0)
end



process InkBulletFade(x,y,z);
begin
ctype=c_scroll;
graph=169;
alpha=100;
repeat
  alpha-=5;
  frame(50);
until(alpha<0)
end



process Boss5();
begin

Boss5Part1(640,240,7);
Boss5Part2(640,240,6);
Boss5Part3(640,240,5);

end



process Boss5Part1(x,y,z);
private
int Counter;
int Counter2;
begin
ctype=c_scroll;
graph=202;

loop
  Counter++;
  if (Counter>80 and Counter<160) x-=3; end
  if (Counter>160 and Counter<320) x+=3; end
  if (Counter>320 and Counter<400) x-=3; end
  if (Counter==800) Counter=0; end

  Counter2++;
  if (Counter2>0 and Counter2<10) size+=1; end
  if (Counter2>10 and Counter2<20) size-=1; end
  if (Counter2==21) Counter2=0; end

  frame(50);
end
end



process Boss5Part2(x,y,z);
private
int Counter;
int Counter2;
begin
ctype=c_scroll;
graph=203;

Counter2=5;
loop
  Counter++;
  if (Counter>80 and Counter<160) x-=3; end
  if (Counter>160 and Counter<320) x+=3; end
  if (Counter>320 and Counter<400) x-=3; end
  if (Counter==800) Counter=0; end

  Counter2++;
  if (Counter2>0 and Counter2<10) size+=1; end
  if (Counter2>10 and Counter2<20) size-=1; end
  if (Counter2==21) Counter2=0; end

  frame(50);
end
end



process Boss5Part3(x,y,z);
private
int Counter;
int Counter2;
begin
ctype=c_scroll;
graph=204;

Counter2=10;
loop
  Counter++;
  if (Counter>80 and Counter<160) x-=3; if (rand(1,30)==1) Laser(x-50,y+11,z); Laser(x+50,y+11,z); play_wav(Laser,0); end end
  if (Counter>160 and Counter<320) x+=3; if (rand(1,30)==1) Laser(x-50,y+11,z); Laser(x+50,y+11,z); play_wav(Laser,0); end end
  if (Counter>320 and Counter<400) x-=3; if (rand(1,30)==1) Laser(x-50,y+11,z); Laser(x+50,y+11,z); play_wav(Laser,0); end end
  if (Counter==800) Counter=0; end

  if (Counter==500)
    Shockwave(x-29,y-5,z-1,207);
    Shockwave(x+29,y-5,z-1,207);
    play_wav(Launch,0);
    play_wav(Launch,0);
    CreateSparks(x-29,y-5,z-1,200,10,rand(2,4),rand(5,7),5);
    CreateSparks(x+29,y-5,z-1,200,10,rand(2,4),rand(5,7),5);
    Mortar(x-29,y-5,z-1);
    Mortar(x+29,y-5,z-1);
  end

  if (Counter==550)
    Shockwave(x-29,y-5,z-1,207);
    Shockwave(x+29,y-5,z-1,207);
    play_wav(Launch,0);
    play_wav(Launch,0);
    CreateSparks(x-29,y-5,z-1,200,10,rand(2,4),rand(5,7),5);
    CreateSparks(x+29,y-5,z-1,200,10,rand(2,4),rand(5,7),5);
    Mortar(x-29,y-5,z-1);
    Mortar(x+29,y-5,z-1);
  end

  if (Counter==600)
    Shockwave(x-29,y-5,z-1,207);
    Shockwave(x+29,y-5,z-1,207);
    play_wav(Launch,0);
    play_wav(Launch,0);
    CreateSparks(x-29,y-5,z-1,200,10,rand(2,4),rand(5,7),5);
    CreateSparks(x+29,y-5,z-1,200,10,rand(2,4),rand(5,7),5);
    Mortar(x-29,y-5,z-1);
    Mortar(x+29,y-5,z-1);
  end
  
  if (Counter==650)
    Shockwave(x-29,y-5,z-1,207);
    Shockwave(x+29,y-5,z-1,207);
    play_wav(Launch,0);
    play_wav(Launch,0);
    CreateSparks(x-29,y-5,z-1,200,10,rand(2,4),rand(5,7),5);
    CreateSparks(x+29,y-5,z-1,200,10,rand(2,4),rand(5,7),5);
    Mortar(x-29,y-5,z-1);
    Mortar(x+29,y-5,z-1);
  end

  if (Counter==700) Beam(x,y,z+2); end

  Counter2++;
  if (Counter2>0 and Counter2<10) size+=1; end
  if (Counter2>10 and Counter2<20) size-=1; end
  if (Counter2==21) Counter2=0; end

  frame(50);
end
end




process Laser(x,y,z);
begin
ctype=c_scroll;
graph=206;
size=200;
flags=16;
if (collision(type Laser)) return; end
repeat
  y+=10;
  if (rand(1,3)==1) LaserTrail(x+rand(-4,4),y-15,z); end
  frame;
until(x<0)
end



process LaserTrail(x,y,z);
begin
ctype=c_scroll;
graph=212;
alpha=200;
repeat
  alpha-=10;
  frame(50);
until(alpha<0)
end




process Beam(x,y,z);
begin
ctype=c_scroll;
graph=211;
size=0;
alpha=100;
flags=16;
play_wav(Beam,0);
repeat
  y+=5;
  alpha+=1;
  size+=2;
  frame(50);
until(size==100);
frame; frame; frame; frame; frame;
repeat
  y-=5;
  alpha-=1;
  size-=2;
  frame(25);
until(size==0);
end



process Mortar(x,y,z);
private
int Counter;
begin
ctype=c_scroll;
graph=205;
repeat
  y-=10;
  size+=20;
  frame;
until(size==300);
graph=0;
repeat
  Counter++;
  frame;
until(Counter==50);
graph=205;
repeat
  x=rand(353,929);
  y=rand(266,690);
  frame(0);
until(collision(type LevelCheck)==0 and collision(type NoEnemyArea)==0 and collision(type BoxEnemy)==0 and collision(type Player)==0)

MortarShadow(x,y,9);
y-=300;
repeat
  y+=12;
  size-=10;
  frame;
until(size==50);

play_wav(Explode,0);
Shockwave2(x,y,z-1,213);
CreateSparks(x,y,z-1,200,20,rand(2,4),rand(5,7),5);

end



process MortarShadow(x,y,z);
begin
ctype=c_scroll;
graph=210;
alpha=50;

size=400;
repeat
  alpha+=1;
  size-=10;
  frame;
until(size==100);

end



process TitleSmallBall(x,y,z,Mode);
private
int MoveAnimation;
begin
graph=84;
size=200;

repeat
  angle+=2000;

  MoveAnimation++;
  if (MoveAnimation==1 or MoveAnimation==2) graph=84; end
  if (MoveAnimation==3 or MoveAnimation==4) graph=85; end
  if (MoveAnimation==5 or MoveAnimation==6) graph=86; end
  if (MoveAnimation==7 or MoveAnimation==8) graph=85; end
  if (MoveAnimation=>9) MoveAnimation=0; end
  
  size-=5;
  
  frame;
until (size==100);

loop
  angle+=2000;

  MoveAnimation++;
  if (MoveAnimation==1 or MoveAnimation==2) graph=84; end
  if (MoveAnimation==3 or MoveAnimation==4) graph=85; end
  if (MoveAnimation==5 or MoveAnimation==6) graph=86; end
  if (MoveAnimation==7 or MoveAnimation==8) graph=85; end
  if (MoveAnimation=>9) MoveAnimation=0; end
  
  frame;
end
end


process MenuOption(x,y,z,graph,Counter,Mode);
private
int Counter2;
begin
size=80+Counter;
if (Mode==1) flags=4; end
loop
  Counter++;
  if (Counter>0 and Counter<20) size+=1; end
  if (Counter>20 and Counter<40) size-=1; end
  if (Counter==41) Counter=0; end
  frame(50);
  if (MenuTransition==1)
    repeat
      size-=10;
      alpha-=30;
      Counter2++;
      frame;
    until(Counter2==10)
    return;
  end
  
end
end


process MenuSelector(x,y,z);
private
int MoveAnimation;
begin
graph=95;
loop

  if (MainMenuSelection==1 and x==160) if (y<150) y+=2; end if (y>150) y-=2; end end
  if (MainMenuSelection==2 and x==160) if (y<210) y+=2; end if (y>210) y-=2; end end
  if (MainMenuSelection==3 and x==160) if (y<270) y+=2; end if (y>270) y-=2; end end
  if (MainMenuSelection==4 and x==160) if (y<330) y+=2; end if (y>330) y-=2; end end
  if (MainMenuSelection==5 and x==160) if (y<390) y+=2; end if (y>390) y-=2; end end
  if (MainMenuSelection==6 and x==160) if (y<450) y+=2; end if (y>450) y-=2; end end

  if (LevelMenuSelection==1 and x==480) if (y<30) y+=2; end if (y>30) y-=2; end end
  if (LevelMenuSelection==2 and x==480) if (y<60) y+=2; end if (y>60) y-=2; end end
  if (LevelMenuSelection==3 and x==480) if (y<90) y+=2; end if (y>90) y-=2; end end
  if (LevelMenuSelection==4 and x==480) if (y<120) y+=2; end if (y>120) y-=2; end end
  if (LevelMenuSelection==5 and x==480) if (y<150) y+=2; end if (y>150) y-=2; end end
  if (LevelMenuSelection==6 and x==480) if (y<180) y+=2; end if (y>180) y-=2; end end
  if (LevelMenuSelection==7 and x==480) if (y<210) y+=2; end if (y>210) y-=2; end end
  if (LevelMenuSelection==8 and x==480) if (y<240) y+=2; end if (y>240) y-=2; end end
  if (LevelMenuSelection==9 and x==480) if (y<270) y+=2; end if (y>270) y-=2; end end
  if (LevelMenuSelection==10 and x==480) if (y<300) y+=2; end if (y>300) y-=2; end end
  if (LevelMenuSelection==11 and x==480) if (y<330) y+=2; end if (y>330) y-=2; end end
  if (LevelMenuSelection==12 and x==480) if (y<360) y+=2; end if (y>360) y-=2; end end
  if (LevelMenuSelection==13 and x==480) if (y<390) y+=2; end if (y>390) y-=2; end end
  if (LevelMenuSelection==14 and x==480) if (y<420) y+=2; end if (y>420) y-=2; end end
  if (LevelMenuSelection==15 and x==480) if (y<450) y+=2; end if (y>450) y-=2; end end

  MoveAnimation++;
  if (MoveAnimation>0 and MoveAnimation<16) graph=95; end
  if (MoveAnimation>16 and MoveAnimation<32) graph=96; end
  if (MoveAnimation>32 and MoveAnimation<48) graph=97; end
  if (MoveAnimation>48 and MoveAnimation<64) graph=96; end
  if (MoveAnimation=>64) MoveAnimation=0; end

  frame(10);
end
end



process GameOver();
private
int Counter;
begin

let_me_alone();
delete_text(0);
stop_scroll(0);

DisplayScreenObject(320,239,2,114,100,0);
DisplayScreenObject(320,240,0,73,100,0);

FadeOut(75);

Counter=0; repeat Counter++; frame; until(Counter==30)
SmallBallAnimation2(205,255,1,28);

Counter=0; repeat Counter++; frame; until(Counter==30)
ZoomOut(320,100,0,113,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,100,1,2);
  Particle_Splash(320,100,1,2);
  Particle_Splash(420,100,1,2);
until(Counter==8)

write(0,200,350,0,"Total Score :");
write_int(0,288,350,0,&score);

Counter=0; repeat Counter++; frame; until(Counter==30)

repeat frame; until(key(_space) or key(_enter))

delete_text(0);
FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)
let_me_alone();
delete_text(0);
MainMenu();

end



process WinGame();
private
int Counter;
begin

let_me_alone();
delete_text(0);
stop_scroll(0);

DisplayScreenObject(320,239,2,45,100,0);
DisplayScreenObject(320,240,0,73,100,0);

FadeOut(75);

Counter=0; repeat Counter++; frame; until(Counter==30)
SmallBallAnimation3(205,255,1,28);

Counter=0; repeat Counter++; frame; until(Counter==30)
ZoomOut(320,100,0,43,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,100,1,2);
  Particle_Splash(320,100,1,2);
  Particle_Splash(420,100,1,2);
until(Counter==8)
Counter=0; repeat Counter++; frame; until(Counter==20)
ZoomOut(320,380,0,44,0,10,1);
Counter=0;
repeat
  Counter++;
  Particle_Splash(220,380,1,2);
  Particle_Splash(320,380,1,2);
  Particle_Splash(420,380,1,2);
until(Counter==8)

write(0,200,420,0,"Total Score :");
write_int(0,288,420,0,&score);

Counter=0; repeat Counter++; frame; until(Counter==30)

repeat frame; until(key(_space) or key(_enter))

delete_text(0);
FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)
let_me_alone();
delete_text(0);
MainMenu();

end



process Pause();
private
int Counter;
begin

loop

  if (key(_esc))
    play_wav(Bip,0); play_wav(Bip,0);
    frame; frame; frame; frame;
    ZoomOut(320,100,0,118,0,10,1);
    Counter=0;
    repeat
      Counter++;
      Particle_Splash(220,100,1,2);
      Particle_Splash(320,100,1,2);
      Particle_Splash(420,100,1,2);
    until(Counter==8)  
    if (Level==0) signal(type Level0, s_freeze_tree); end
    if (Level==1) signal(type Level1, s_freeze_tree); end
    if (Level==2) signal(type Level3, s_freeze_tree); end
    if (Level==3) signal(type Level4, s_freeze_tree); end
    if (Level==4) signal(type Level5, s_freeze_tree); end
    if (Level==5) signal(type Level6, s_freeze_tree); end
    if (Level==6) signal(type Level7, s_freeze_tree); end
    if (Level==7) signal(type Level8, s_freeze_tree); end
    if (Level==8) signal(type Level9, s_freeze_tree); end
    if (Level==9) signal(type Level10, s_freeze_tree); end
    if (Level==10) signal(type Level11, s_freeze_tree); end
    if (Level==11) signal(type Level12, s_freeze_tree); end
    if (Level==12) signal(type Level13, s_freeze_tree); end
    if (Level==13) signal(type Level14, s_freeze_tree); end
    if (Level==14) signal(type Level15, s_freeze_tree); end
    signal(type Pause, s_wakeup);
    signal(type Particle_Splash, s_wakeup);
    signal(type ZoomOut, s_wakeup);
    
    repeat frame; until(key(_esc) or key(_space) or key(_enter));
    if (key(_esc))
      FadeIn(75);
      Counter=0; repeat Counter++; frame; until(Counter==30)
      delete_text(0);
      let_me_alone();
      MainMenu();
    end
    
    if (Level==0) signal(type Level0, s_wakeup_tree); end
    if (Level==1) signal(type Level1, s_wakeup_tree); end
    if (Level==2) signal(type Level3, s_wakeup_tree); end
    if (Level==3) signal(type Level4, s_wakeup_tree); end
    if (Level==4) signal(type Level5, s_wakeup_tree); end
    if (Level==5) signal(type Level6, s_wakeup_tree); end
    if (Level==6) signal(type Level7, s_wakeup_tree); end
    if (Level==7) signal(type Level8, s_wakeup_tree); end
    if (Level==8) signal(type Level9, s_wakeup_tree); end
    if (Level==9) signal(type Level10, s_wakeup_tree); end
    if (Level==10) signal(type Level11, s_wakeup_tree); end
    if (Level==11) signal(type Level12, s_wakeup_tree); end
    if (Level==12) signal(type Level13, s_wakeup_tree); end
    if (Level==13) signal(type Level14, s_wakeup_tree); end
    if (Level==14) signal(type Level15, s_wakeup_tree); end
    play_wav(Bip,0); play_wav(Bip,0); play_wav(Bip,0);
    signal(type ZoomOut, s_kill);   
  end
frame;
end
end



process SlowDownWorldObject(x,y,z,graph,size,Mode);
begin
ctype=c_scroll;
if (Mode==0 or Mode==1) alpha=0; end
if (Mode==1) flags=1; end
loop frame; end
end



process WhirlWind(Min_X,Min_Y,Max_X,Max_Y,z,Model);
private
int Counter;
begin
if (Model==1) graph=127; end
ctype=c_scroll;
alpha=0;
size=0;
repeat
  x=rand(Min_X,Max_X);
  y=rand(Min_Y,Max_Y);
  frame(0);
until(collision(type LevelCheck)==0 and collision(type NoEnemyArea)==0 and collision(type BoxEnemy)==0 and collision(type Player)==0)

repeat
  size+=5;
  x+=4;
  alpha+=10;
  angle+=10000;
  frame;
until (size==120)

repeat
  size-=5;
  x+=4;
  alpha-=10;
  angle+=10000;
  frame;
until (size==0)

end


process Wind(x,y,z,Mode);
begin
if (Mode==1) graph=154; alpha=50; end
loop
  x+=10;
  if (x==960) x=-320; end
  frame;
end
end


process ConveyorRight(x,y,z);
private
int Counter;
begin
ctype=c_scroll;
loop
  Counter++;
  if (Counter==1 or Counter==2) graph=173; end
  if (Counter==3 or Counter==4) graph=174; end  
  if (Counter==5 or Counter==6) graph=175; end
  if (Counter==7 or Counter==8) graph=176; end
  if (Counter==9 or Counter==10) graph=177; end
  if (Counter==11 or Counter==12) graph=178; end
  if (Counter==13 or Counter==14) graph=179; end
  if (Counter==15 or Counter==16) graph=180; end
  if (Counter==17 or Counter==18) graph=181; end
  if (Counter==19 or Counter==20) graph=182; end  
  if (Counter==21) Counter=0; end
  frame(75);
end
end



process ConveyorDown(x,y,z);
private
int Counter;
begin
ctype=c_scroll;
angle=270000;
loop
  Counter++;
  if (Counter==1 or Counter==2) graph=173; end
  if (Counter==3 or Counter==4) graph=174; end  
  if (Counter==5 or Counter==6) graph=175; end
  if (Counter==7 or Counter==8) graph=176; end
  if (Counter==9 or Counter==10) graph=177; end
  if (Counter==11 or Counter==12) graph=178; end
  if (Counter==13 or Counter==14) graph=179; end
  if (Counter==15 or Counter==16) graph=180; end
  if (Counter==17 or Counter==18) graph=181; end
  if (Counter==19 or Counter==20) graph=182; end  
  if (Counter==21) Counter=0; end
  frame(75);
end
end



process ConveyorLeft(x,y,z);
private
int Counter;
begin
ctype=c_scroll;
flags=1;
loop
  Counter++;
  if (Counter==1 or Counter==2) graph=173; end
  if (Counter==3 or Counter==4) graph=174; end  
  if (Counter==5 or Counter==6) graph=175; end
  if (Counter==7 or Counter==8) graph=176; end
  if (Counter==9 or Counter==10) graph=177; end
  if (Counter==11 or Counter==12) graph=178; end
  if (Counter==13 or Counter==14) graph=179; end
  if (Counter==15 or Counter==16) graph=180; end
  if (Counter==17 or Counter==18) graph=181; end
  if (Counter==19 or Counter==20) graph=182; end  
  if (Counter==21) Counter=0; end
  frame(75);
end
end



process ConveyorUp(x,y,z);
private
int Counter;
begin
ctype=c_scroll;
angle=90000;
loop
  Counter++;
  if (Counter==1 or Counter==2) graph=173; end
  if (Counter==3 or Counter==4) graph=174; end  
  if (Counter==5 or Counter==6) graph=175; end
  if (Counter==7 or Counter==8) graph=176; end
  if (Counter==9 or Counter==10) graph=177; end
  if (Counter==11 or Counter==12) graph=178; end
  if (Counter==13 or Counter==14) graph=179; end
  if (Counter==15 or Counter==16) graph=180; end
  if (Counter==17 or Counter==18) graph=181; end
  if (Counter==19 or Counter==20) graph=182; end  
  if (Counter==21) Counter=0; end
  frame(75);
end
end


process SparkEnemy(x,y,z,Velocity);
begin
ctype=c_scroll;
graph=184;
SparkEnemyLight(x,y,z+3);
loop
  SparkEnemy_Alpha=rand(150,200);
  alpha=SparkEnemy_Alpha;
  angle+=5000;
  if (angle==360000) angle=0; end
  Spark_X=x;
  Spark_Y=y;
  
  if (x<Player_X) x+=Velocity; end
  if (x>Player_X) x-=Velocity; end
  if (y<Player_Y) y+=Velocity; end
  if (y>Player_Y) y-=Velocity; end
  
  Spark(x+rand(-7,7),y+rand(-7,7),z+1,SparkEnemy_Alpha,3,1,4);
  
  frame;
end
end



process SparkEnemyLight(x,y,z);
begin
ctype=c_scroll;
graph=185;
alpha=150;
loop
  alpha=SparkEnemy_Alpha-50;
  x=Spark_X;
  y=Spark_Y;
  frame;
end
end


process SpinAlarm(x,y,z);
private
int Counter;
int Direction;
begin
angle=0;
Direction=rand(1,2);
size=200;
flags=16;
graph=215;
loop
  if (Direction==1) Counter+=-40; end
  if (Direction==2) Counter+=40; end
  if (Counter>3000) Counter=3000; end
  if (Counter<-5000) Counter=-5000; end

  angle=angle+Counter;

  if (angle>360000) Direction=1; end
  if (angle<270000) Direction=2; end

  frame;
end
end


process Bees(x,y,z);
begin
ctype=c_scroll;
graph=216;
BeeShadow();
loop
  angle-=3000;
  if (angle<-360000) angle=0; end
  x+=rand(-1,1);
  y+=rand(-1,1);
 
  if (x<353) x=353; end
  if (y<266) y=266; end
  if (x>929) x=929; end
  if (y>690) y=690; end
  
  Bee_X=x;
  Bee_Y=y;
  Bee_Angle=angle;
  
  frame;
end
end


process BeeShadow();
begin
z=6;
ctype=c_scroll;
graph=216;
flags=32;
loop
  x=Bee_X+10;
  y=Bee_Y+10;
  angle=Bee_Angle;
  frame;
end
end









process Original3D();
private
int Counter;
begin

let_me_alone();
delete_text(0);

stop_wav(0);
stop_song();
Song=load_song("Music/changeball.ogg");
play_song(Song,99);

delete_3dobject(Background3D);
delete_3dobject(BackgroundMap);
stop_hiper3d();

BackgroundMap=new_map(640,480,16);
init_hiper3d(0,BackgroundMap);

Cam_X=0;
Cam_Y=0;
Lives=3;

set_camera_pos(Cam_X,Cam_Y,80);
set_camera_rot(0,0,0);
enable_culling(1);
enable3d(1);

Sphere=load_mesh("Models/sphere.md2");

DrawBackground(320,240,10);
DrawBkg(320,240,14,10);

BoxEnemy2(rand(-64,64),rand(-48,48),0,rand(1,4));
Point2(rand(-64,64),rand(-48,48),0);

MakeTiles();


FadeOut(75);
Counter=0; repeat Counter++; frame; until(Counter==30)

Counter=0;
ZoomOut(320,80,0,116,0,10,1);
repeat
  Counter++;
  Particle_Splash(220,80,1,2);
  Particle_Splash(320,80,1,2);
  Particle_Splash(420,80,1,2);
until(Counter==8)

write(0,260,200,0,"High Score :");
write_int(0,340,200,0,&Saves[1].OriginalScore);
write(0,260,210,0,"Max Points :");
write_int(0,340,210,0,&Saves[1].OriginalPoints);

repeat frame; until(key(_enter) or key(_space) or key(_esc))

signal(type ZoomOut, s_kill);
if (key(_esc))
  delete_text(0);
  FadeIn(75);
  Counter=0; repeat Counter++; frame; until(Counter==30)
  delete_mesh(Sphere);
  delete_all_3dobjects();
  MainMenu();
end

delete_text(0);
write_int(0,1,1,0,&Score);
Player2(0,0,0);
ScoreTimer();

repeat frame; until(key(_esc))

FadeIn(75);
Counter=0; repeat Counter++; frame; until(Counter==30)
delete_text(0);
Original3D();

end



process Player2(x,y,z);
private
float Counter;
int SphereModel;
begin

PlayerDead=0;
SphereModel=new_3dobject(2,0,0,0,0.2,0.2,0.2);
set_mesh(SphereModel,Sphere);
set_texture(SphereModel,load_texture(0,1));

Counter=0.50;
repeat
  set_size(SphereModel,Counter,Counter,Counter);
  Counter-=0.05;
  frame; frame;
until(Counter<0.15);

InvincibleCounter=30;
set_pos(SphereModel,Player_X,Player_Y,0);

loop

  if (InvincibleCounter>0) InvincibleCounter--; end
  if (InvincibleCounter==29 or InvincibleCounter==28) set_texture(SphereModel,load_texture(0,117)); end
  if (InvincibleCounter==27 or InvincibleCounter==26) set_texture(SphereModel,load_texture(0,1)); end
  if (InvincibleCounter==25 or InvincibleCounter==24) set_texture(SphereModel,load_texture(0,117)); end
  if (InvincibleCounter==23 or InvincibleCounter==22) set_texture(SphereModel,load_texture(0,1)); end
  if (InvincibleCounter==21 or InvincibleCounter==20) set_texture(SphereModel,load_texture(0,117)); end
  if (InvincibleCounter==19 or InvincibleCounter==18) set_texture(SphereModel,load_texture(0,1)); end
  if (InvincibleCounter==17 or InvincibleCounter==16) set_texture(SphereModel,load_texture(0,117)); end
  if (InvincibleCounter==15 or InvincibleCounter==14) set_texture(SphereModel,load_texture(0,1)); end
  if (InvincibleCounter==13 or InvincibleCounter==12) set_texture(SphereModel,load_texture(0,117)); end
  if (InvincibleCounter==11 or InvincibleCounter==10) set_texture(SphereModel,load_texture(0,1)); end
  if (InvincibleCounter==9 or InvincibleCounter==8) set_texture(SphereModel,load_texture(0,117)); end
  if (InvincibleCounter==7 or InvincibleCounter==6) set_texture(SphereModel,load_texture(0,1)); end
  if (InvincibleCounter==5 or InvincibleCounter==4) set_texture(SphereModel,load_texture(0,117)); end
  if (InvincibleCounter==3 or InvincibleCounter==2) set_texture(SphereModel,load_texture(0,1)); end
 
      
  if(key(_up)) Player_Y+=2; Player_Rotation_X-=20; end
  if(key(_down)) Player_Y-=2; Player_Rotation_X+=20; end
  if(key(_left)) Player_X-=2; Player_Rotation_Y-=20; end
  if(key(_right)) Player_X+=2; Player_Rotation_Y+=20; end
  
  if (Player_X>64) Player_X-=2; end
  if (Player_X<-64) Player_X+=2; end
  if (Player_Y>48) Player_Y-=2; end
  if (Player_Y<-48) Player_Y+=2; end
      
  set_pos(SphereModel,Player_X,Player_Y,0);
  set_rot(SphereModel,Player_Rotation_X,Player_Rotation_Y, 0);
  
  if (PlayerDead==1)
    InvincibleCounter=30;
    PlayerDead=0;
    Player_X=0; Player_Y=0;
    Lives--;
    Counter=0.25;
    repeat
      set_size(SphereModel,Counter,Counter,Counter);
      Counter-=0.05;
      frame; frame;
    until(Counter<0);
    play_wav(Poff,0);
    delete_3dobject(SphereModel);
    
    if (Lives==0)
      if (Score>Saves[1].OriginalScore)
        Saves[1].OriginalScore=Score;
      end
      if (Points>Saves[1].OriginalPoints)
        Saves[1].OriginalPoints=Points;
      end
      save("score.dat",Saves);
      write(0,280,200,0,"Score :");
      write_int(0,330,200,0,&Score);
      write(0,280,210,0,"Points :");
      write_int(0,330,210,0,&Points);
      
      Counter=0;
      ZoomOut(320,80,0,113,0,10,1);
      repeat
        Counter++;
        Particle_Splash(220,80,1,2);
        Particle_Splash(320,80,1,2);
        Particle_Splash(420,80,1,2);
      until(Counter==8)      
      
      repeat frame; until(key(_enter) or key(_space) or key(_esc))
      Original3D();
    end
    
    Player2(0,0,0);
    return;
  end
  
  frame;
end
end



process BoxEnemy2(x,y,z,Direction);
private
int BoxEnemy;
int Enemy_Rotation_X;
int Enemy_Rotation_Y;

begin

BoxEnemy=new_3dobject(1,0,0,0,4,4,4);
set_texture(BoxEnemy,load_texture(0,2));
set_pos(BoxEnemy,x,y,z);
loop
  if(Direction==1) y++; Enemy_Rotation_X-=20; end
  if(Direction==2) y--; Enemy_Rotation_X+=20; end
  if(Direction==3) x--; Enemy_Rotation_Y-=20; end
  if(Direction==4) x++; Enemy_Rotation_Y+=20; end
  
  if (x>64) Direction=3; end
  if (x<-64) Direction=4; end
  if (y>48) Direction=2; end
  if (y<-48) Direction=1; end
      
  set_pos(BoxEnemy,x,y,0);
  set_rot(BoxEnemy,Enemy_Rotation_X,Enemy_Rotation_Y, 0);
  
  if (x>Player_X-6 and x<Player_X+6 and y>Player_Y-6 and y<Player_Y+6 and InvincibleCounter==0) PlayerDead=1; end
  
  frame;
end
end



process Point2(x,y,z);
private
int Point;
int Counter;

begin

Point=new_3dobject(2,0,0,0,0.2,0.2,0.2);
set_mesh(Point,Sphere);
set_texture(Point,load_texture(0,42));
set_pos(Point,x,y,z);

loop

  if(x>Player_X-6 and x<Player_X+6 and y>Player_Y-6 and y<Player_Y+6)
    play_wav(Pop,0);
    Counter=1;
    repeat
      set_size(Point,Counter,Counter, Counter);
      Counter+=1;
      frame;
    until(Counter==10);
    Score+=ScoreCounter;
    ScoreCounter=640;
    Points++;
    delete_3dobject(Point);
    Point2(rand(-64,64),rand(-48,48),0);
    Change(rand(1,3));
    BoxEnemy2(rand(-64,64),rand(-48,48),0,rand(1,4));
    return;
  end
  
  frame;
end
end



process Change(Number);
private
int Counter;
int Tmp_X;
int Tmp_Y;
begin

if (Number==1 and Camera_Rotation_Z==0)
  repeat
    Camera_Rotation_Z+=2;
    set_camera_rot(0,0,Camera_Rotation_Z);
    frame;
  until(Camera_Rotation_Z==180)
  return;
end

if (Number==1 and Camera_Rotation_Z==180)
  repeat
    Camera_Rotation_Z+=2;
    set_camera_rot(0,0,Camera_Rotation_Z);
    frame;
  until(Camera_Rotation_Z==360)
  Camera_Rotation_Z=0;
  return;
end

if (Number==2 and On==0)
  On=1;
  repeat
    Counter+=1;
    if (Tmp_X>Player_X) Tmp_X--; end
    if (Tmp_X<Player_X) Tmp_X++; end
    if (Tmp_Y>Player_Y) Tmp_Y--; end
    if (Tmp_Y<Player_Y) Tmp_Y++; end
    set_camera_pos(Tmp_X,Tmp_Y,80-Counter);
    frame(50);
  until(Counter==40)
  Counter=0;
  repeat
    Counter+=1;
    set_camera_pos(Player_X,Player_Y,40);
    frame;
  until(Counter==100)
  Counter=40;
  Tmp_X=Player_X;
  Tmp_Y=Player_Y;
  repeat
    Counter--;
    set_camera_pos(Tmp_X,Tmp_Y,80-Counter);
    if (Tmp_X>0) Tmp_X--; end
    if (Tmp_X<0) Tmp_X++; end
    if (Tmp_Y>0) Tmp_Y--; end
    if (Tmp_Y<0) Tmp_Y++; end    
    frame(50);
  until(Counter==0)
  set_camera_pos(0,0,80);
  On=0;
  return;
end

end


process MakeTiles();
begin
x=-72;
y=-56;
repeat
  repeat
    BkgTile(x,y,-10);
    x+=8;
  until (x>72);
  x=-72;
  y+=8;
until (y>56);
end


process BkgTile(x,y,z);
private
int Tile;
int Tile_Rotation_X;
int Tile_Rotation_Y;
int Tile_Rotation_Z;
int FadeTimer;
begin

Tile=new_3dobject(1,0,0,0,4.5,4.5,4.5);
set_texture(Tile,load_texture(0,6));
set_pos(Tile,x,y,z);
loop
/*
  if(x>Player_X-6 and x<Player_X+6 and y>Player_Y-6 and y<Player_Y+6)
    set_texture(Tile,load_texture(0,3));
    FadeTimer=11;
  end
  
  if (FadeTimer>0) FadeTimer--; end
  if (FadeTimer==10 or FadeTimer==9 or FadeTimer==8) set_texture(Tile,load_texture(0,4)); end
  if (FadeTimer==7 or FadeTimer==6 or FadeTimer==5) set_texture(Tile,load_texture(0,5)); end  
  if (FadeTimer==4 or FadeTimer==3 or FadeTimer==2) set_texture(Tile,load_texture(0,6)); end
*/
  frame;
end
end


process DrawBkg(x,y,z,graph);
begin
loop frame; end
end